//+------------------------------------------------------------------+
//|                               FLI_SR_FIB_FirstLevel_Distance.mq4 |
//|                   Copyright  2009, Francesco Marasco aka flinux |
//|                                       E-Mail: fmarasco@gmail.com |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators.                                         |
//|                                                                  |
//|   PayPal - fmarasco@gmail.com                                    |  
//+------------------------------------------------------------------+

#property copyright "Francesco Marasco"
#property link      "http://mt4forex.blogspot.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 FireBrick

extern double    iLevel1     = 0.24; 
extern int       MaxPastBars = 20;
extern bool      Show.Label  = true;

double BufL[];
double BufH[];
double digits, point;
int period;
string Tag = "FLI";

int init()
{
   digits       = Digits;
   point        = Point;
   period       = Period();
     
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }

   IndicatorBuffers(2); 
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BufH); 
   SetIndexStyle(1,DRAW_LINE); 
   SetIndexBuffer(1,BufL); 
   return(0);
}

int deinit()
{
   ObDeleteObjectsByPrefix(Tag);  
}

int start()
{
   int counted_bars=IndicatorCounted();
   int i, limit;
   
   limit = Bars - counted_bars;
   
   for (i = 0; i < limit; i++)
   {
      BufH[i] = High[i]+High[i]*iLevel1*point;
      BufL[i] = Low[i]-Low[i]*iLevel1*point;
   }
   
   ObDeleteObjectsByPrefix(Tag);
   
   for (i = 2; i < MaxPastBars; i++)
   {
      if (BufH[i]<BufH[i-1]&&BufH[i]<BufH[i-2]&&BufH[i]<BufH[i+1]&&BufH[i]<BufH[i+2])
         DrawPriceTrendLines(Tag+DoubleToStr(i,0),Time[i],Time[0],BufH[i],BufH[i],White,STYLE_DOT,1);
      if (BufL[i]>BufL[i-1]&&BufL[i]>BufL[i-2]&&BufL[i]>BufL[i+1]&&BufL[i]>BufL[i+2])
         DrawPriceTrendLines(Tag+DoubleToStr(i,0),Time[i],Time[0],BufL[i],BufL[i],White,STYLE_DOT,1);
   }

   return(0);
}

void DrawPriceTrendLines(string objname, datetime x1, datetime x2, double y1, 
                        double y2, color lineColor, int style, int width)
{
   ObjectDelete(objname);
   ObjectCreate(objname, OBJ_TREND, 0, x1, y1, x2, y2, 0, 0);
   ObjectSet(objname, OBJPROP_RAY, true);

   ObjectSet(objname, OBJPROP_COLOR, lineColor);
   ObjectSet(objname, OBJPROP_STYLE, style);
   ObjectSet(objname, OBJPROP_WIDTH, width);

   if(Show.Label && y1 == y2)
   {
      string Obj0002 = objname+"linelbl" ;
      ObjectDelete(Obj0002);
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, Time[0]+period*60, y1);
         ObjectSetText(Obj0002, DoubleToStr(y1 ,digits) , 8, "Arial", lineColor);
      }
      else
      {
         ObjectMove(Obj0002, 0, Time[0]+period*60, y1);
      }
   }
}

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
   {
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix) 
      { 
         i++; 
         continue;
      }
      ObjectDelete(ObjName);
   }
}